#ifndef _LAVC_WRAPPER_H_
#define _LAVC_WRAPPER_H_

#ifdef LAVC_WRAPPING
#define AVSC_EXPORT EXTERN_C __declspec(dllexport)
#else
#define AVSC_EXPORT EXTERN_C __declspec(dllimport)
#endif

#define AVSC_CC __cdecl

typedef unsigned char  uint8_t;

typedef struct {
    uint8_t *data[4]; // order: YUV
    int linesize[4];
} PictureYV12;

typedef struct {
    struct AVCodecContext *c;
    struct AVFrame *picture;
    int outbuf_size;
    FILE *f;
    uint8_t *outbuf;
    char *stats;
} WrapperContext;

typedef struct {
    int width, height;
	int dia, predia;
	int cmp, subcmp;
	int preme;
	int v4mv;
} LavcOpts;

typedef struct {
	void (*init)();
	void (*config)(WrapperContext *wc, LavcOpts *opt);
	void (*put_image)(WrapperContext *wc, PictureYV12 *inpic);
	void (*finish)(WrapperContext *wc);
	int lavc_build;
} LavcFuncs;

typedef LavcFuncs* (AVSC_CC sclavc_funcs_t)();

#endif //_LAVC_WRAPPER_H_
